package org.ow2.util.ee.metadata.common.impl.configurator;

import org.ow2.util.ee.metadata.common.api.ICommonClassMetadata;
import org.ow2.util.ee.metadata.common.api.ICommonFieldMetadata;
import org.ow2.util.ee.metadata.common.api.ICommonMethodMetadata;
import org.ow2.util.scan.api.configurator.metadata.FieldMetadataConfigurator;

/**
 * CommonFieldMetadataConfigurator.
 * @author Gael Lalire
 * @param <C> class type
 * @param <M> method type
 * @param <F> field type
 */
public abstract class CommonFieldMetadataConfigurator<
    C extends ICommonClassMetadata<C, M, F>,
    M extends ICommonMethodMetadata<C, M, F>,
    F extends ICommonFieldMetadata<C, M, F>>
        extends FieldMetadataConfigurator<C, M, F> {

    /**
     * Constructor.
     * @param fieldMetadata fieldMetadata
     */
    public CommonFieldMetadataConfigurator(final F fieldMetadata) {
        super(fieldMetadata);
    }

    /**
     * register annotation visitor.
     */
    protected void registerAnnotationVisitor() {

        F fieldMetadata = getFieldMetadata();

        // add visitor shared with class and field and method
        CommonMetadataConfigurator.initVisitor(getAnnotationVisitors(), fieldMetadata);

    }

}
