package org.ow2.util.ee.metadata.common.impl.configurator;

import org.ow2.util.ee.metadata.common.api.ICommonClassMetadata;
import org.ow2.util.ee.metadata.common.api.ICommonFieldMetadata;
import org.ow2.util.ee.metadata.common.api.ICommonMethodMetadata;
import org.ow2.util.scan.api.configurator.metadata.MethodMetadataConfigurator;

/**
 * CommonFieldMetadataConfigurator.
 * @author Gael Lalire
 * @param <C> class type
 * @param <M> method type
 * @param <F> field type
 */
public abstract class CommonMethodMetadataConfigurator<
    C extends ICommonClassMetadata<C, M, F>,
    M extends ICommonMethodMetadata<C, M, F>,
    F extends ICommonFieldMetadata<C, M, F>>
        extends MethodMetadataConfigurator<C, M, F> {

    /**
     * Constructor.
     * @param methodMetadata methodMetadata
     */
    public CommonMethodMetadataConfigurator(final M methodMetadata) {
        super(methodMetadata);
    }

    /**
     * register annotation visitor.
     */
    protected void registerAnnotationVisitor() {

        M methodMetadata = getMethodMetadata();

        // add visitor shared with class and field and method
        CommonMetadataConfigurator.initVisitor(getAnnotationVisitors(), methodMetadata);

    }


}
